<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-grades', params: { profil: 'admin' } }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">création d'un grade</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-grade :grade="grade" :corps="corps" />
      <div class="columns is-centered">
        <b-button type="is-primary has-text-weight-semibold" native-type="submit">
          Créer le grade
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormGrade from '~/components/dashboard/grade/champs-form-grade';
import newGrade from '~/components/mixins/gradeMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormGrade,
  },
  async asyncData(context) {
    const grade = newGrade();
    const { content: corps } = await context.$api.corps.all(0, 50);
    return {
      grade,
      corps,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.grades.post(this.grade);
        this.$router.push({ name: 'profil-dashboard-grades', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
